/*
 *  Copyright 2001-2010 Mikhail Kryshen <mikhail@kryshen.net>
 *
 *  This file is part of Graph Game.
 *
 *  Graph Game is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Graph Game is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Graph Game.  If not, see <http://www.gnu.org/licenses/>.
 */
package kryshen.graphg;

import java.util.Enumeration;
import java.util.Vector;

/**
 * Created: Sun Feb  4 16:04:30 2001
 *
 * @author Mikhail Kryshen
 */
class MultiNode  {
    Vector nodes = new Vector();
    Vector edges = new Vector();
    Graph graph;

    int mark;
    Edge pathEdge;

    MultiNode(Graph graph) {
	this.graph = graph;
    }

    void connect(MultiNode gnode) {
        if (this.equals(gnode)) {
            return;
        }

        Enumeration enu = gnode.nodes.elements();
        while (enu.hasMoreElements()) {
            Node gn = (Node) enu.nextElement();
            nodes.addElement(gn);
            gn.multiNode = this;
        }

        enu = gnode.edges.elements();
        while (enu.hasMoreElements()) {
            Edge gl = (Edge) enu.nextElement();
            if (!edges.contains(gl)) {
                edges.addElement(gl);
            }
        }

        graph.multiNodes.removeElement(gnode);
    }
}
