/*
 *  Copyright 2001-2010 Mikhail Kryshen <mikhail@kryshen.net>
 *
 *  This file is part of Graph Game.
 *
 *  Graph Game is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Graph Game is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Graph Game.  If not, see <http://www.gnu.org/licenses/>.
 */
package kryshen.graphg;

abstract class Player {
    static final int CUT = 1;
    static final int SHORT = 2;
    final int player;

    protected Graph graph;
    protected GraphCanvas canvas;
    protected boolean myTurn;

    String name;
    long time = 0;
    int moves = 0;

    Player(String name, int player, GraphCanvas gc) {
	this.name = name;
	this.player = player;
	this.canvas = gc;
	this.graph = canvas.graph;
    }

    protected void move() {}

    synchronized void play() {
	myTurn = true;
	move();
    }

    synchronized void stop() {
	//stoped = true;
    }

    protected synchronized void done() {
	myTurn = false;
	moves++;
	canvas.nextTurn(this);
    }
}
